//
//  UIWindow.swift
//  Panda
//
//  Baby of PandaMom. DO NOT TOUCH.
//

import UIKit

extension PandaChain where Object: UIWindow {
    @discardableResult
    public func screen(_ value: UIScreenConvertible) -> PandaChain {
        object.screen = unbox(value)
        return self
    }

    @discardableResult
    public func windowLevel(_ value: UIWindow.Level) -> PandaChain {
        object.windowLevel = value
        return self
    }

    @discardableResult
    public func rootViewController(_ value: UIViewControllerConvertible?) -> PandaChain {
        object.rootViewController = unbox(value)
        return self
    }
}
